##############################################################################
#    Copyright (C) 2001  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
"""

ADD_CONTENT_PERMISSION = 'Add portal content'

import Globals
import zLOG
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from AccessControl import ClassSecurityInfo
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from General import Playable

factory_type_information = {
      'id': 'MediaCinema',
      'meta_type': 'Media Manager Cinema',
      'description': 'Use ciname to make new Media Cinema',
      'product': 'MMMCore',
      'icon': 'file_icon.gif',
      'factory': 'addMediaCinema',
      'filter_content_types': 0,
      'immediate_view': 'mediacinema_edit_form',
      'actions': 
	      ({'name': 'View',
	        'action': 'mediacinema_view',
		'permissions': ('View',),
		'category': 'object'},
	       {'name': 'Edit',
	        'action': 'mediacinema_edit_form',
		'permissions': ('Modify portal content',),
		'category': 'object'},
	       {'name': 'Play',
	        'action': 'mediacinema_play_form',
		'permissions': ('View',),
		'category': 'object'},
	       {'name': 'Add Part',
	        'action': 'mediacinema_add_part_form',
		'permissions': ('Modify portal content',),
		'category': 'object'})
       }


class MediaCinema( PortalContent
          , DefaultDublinCoreImpl,
	  Playable
          ):
    """
        A Link
    """

    meta_type='Media Manager Cinema'
    portal_type='Object'
    effective_date = expiration_date = None
    _isDiscussable = 1

    security = ClassSecurityInfo()

    def __init__( self
                , id
                , title=''
                , description=''
                ):
        DefaultDublinCoreImpl.__init__(self)
        self.id=id
        self.title=title
        self.parts = [] 
        self.description=description
	zLOG.LOG("MediaCinema", -100, "Made MasterFile %s" % (id))

    def listParts( self ):
	"""
	  List All offsets available
	"""
	zLOG.LOG("MediaCinema", zLOG.INFO, "Listing logics\nCurrent:\n%s" % (self.parts))
	return tuple(self.parts)

    security.declareProtected(View, 'lookupPlayerSource')
    security.declareProtected(View, 'embedPlayer')

    security.declareProtected(View, 'getPart')
    def getPart( self, pIndex ):
	index = int(pIndex)
	zLOG.LOG("MediaCinema", zLOG.TRACE, "Fetching logic %s return: %s" % (index, self.parts[index]))
	return self.parts[index]
	
    security.declareProtected(ManageProperties, 'moveUp')
    def moveUp( self, pIndex ):
	"""
	"""
	index = int(pIndex)
	#raise "DEBUG", "Assign %s to %s" % (id, offset)
	zLOG.LOG("MediaCinema", -100, "moveUp %s" % (index))
	if index>0 and index<len(self.parts):
	  old = self.parts[index-1]
	  self.parts[index-1] = self.parts[index]
	  self.parts[index] = old
	  self._p_changed = 1

    security.declareProtected(ManageProperties, 'moveDown')
    def moveDown( self, pIndex ):
        """
	"""
	index=int(pIndex)
	zLOG.LOG("MediaCinema", zLOG.TRACE, "moveDown %s" % (index))
	if index<len(self.parts)-1 and index>=0:
	  old = self.parts[index+1]
	  self.parts[index+1] = self.parts[index]
	  self.parts[index] = old
	  self._p_changed = 1

    security.declareProtected(ManageProperties, 'delete')
    def delete( self, pIndex ):
        """
	"""
	index=int(pIndex)
	zLOG.LOG("MediaCinema", zLOG.INFO, "delete %s %s" % (index, len(self.parts)))
	if index>=0 and index<len(self.parts):
	  del self.parts[index]
	  self._p_changed = 1
	  zLOG.LOG("MediaCinema", zLOG.INFO, "Deleted %s" %(index))

    security.declareProtected(ManageProperties, 'append')
    def append( self, part ):
	"""
	"""
	zLOG.LOG("MediaCinema", zLOG.INFO, "append %s" % (part))
	self.parts.append(part)
	self._p_changed = 1

    def SearchableText(self):
        """
            text for indexing
        """
        return "%s %s" % (self.title, self.description)

def addMediaCinema(self, id, title='', REQUEST=None):
	ob=MediaCinema(id,title)
	self._setObject(id, ob)

Globals.InitializeClass(MediaCinema)

from Products.CMFCore.register import registerPortalContent
registerPortalContent(MediaCinema,
                      constructors=(addMediaCinema,),
		      action='mediacinema_edit_form',
		      icon='file_icon.gif')
