##############################################################################
#    Copyright (C) 2001  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
"""

ADD_CONTENT_PERMISSION = 'Add portal content'

import zLOG
import Globals
from Globals import PersistentMapping
from Persistence import Persistent

from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.WorkflowCore import WorkflowMethod

from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl

from AccessControl import ClassSecurityInfo


demand_factory_type_information = {
      'id': 'ServerLogic',
      'meta_type': 'Media Manager Server Logic',
      'description': 'Use master file to store link to files',
      'product': 'MMMCore',
      'icon': 'file_icon.gif',
      'factory': 'addServerLogic',
      'filter_content_types': 0,
      'immediate_view': 'serverlogic_edit_form',
      'actions': 
	      ({'name': 'View',
	        'action': 'serverlogic_view',
		'permissions': ('View',),
		'category': 'object'},
	       {'name': 'Edit',
	        'action': 'serverlogic_edit_form',
		'permissions': ('Modify portal content',)})
       }

live_factory_type_information = {
       'id': 'LiveServerLogic',
       'meta_type': 'Media Manager Live Server Logic',
       'description': 'Use fgdfgfdg',
       'product': 'MMMCore',
       'icon': 'file_icon.gif',
       'factory': 'addLiveServerLogic',
       'filter_content_types': 0,
       'immediate_view': 'liveserverlogic_edit_form',
       'actions':
	       ({'name': 'View',
	         'action': 'liveserverlogic_view',
		 'permissions': ('View',),
		 'category': 'object'},
		{'name': 'Edit',
		 'action': 'liveserverlogic_edit_form',
		 'permissions': ('Modify portal content',)})
       }

class ServerLogic( PortalContent
          , DefaultDublinCoreImpl
          ):
    """
        A Link
    """

    meta_type='Media Manager Server Logic'
    portal_type='Object'
    effective_date = expiration_date = None
    _isDiscussable = 1
    

#    medianet = None

    security = ClassSecurityInfo()

    def __init__( self
                , id
                , title=''
                , description=''
                ):
        DefaultDublinCoreImpl.__init__(self)
        self.id=id
        self.title=title
        self.description=description
	self.protocol = ''
	self.host = ''
	self.port = 554
	self.path = '/'
	self.ekstension = ''
	self.ppv_serverid = 'MMManager'

#    def setMedianet( self, medianet ):
#	if isinstance ( medianet,  String ):
#	  medianet = self.restricedTraverse(medianet)
#
#	if not isinstance ( medianet, MedianetFolder ):
#	  raise "Incorrect medianet"
#	self.medianet = medianet
#	self._p_changed = 1
#
#    def getMedianet( self ):
#	return self.medianet

    def edit (self, Protocol, Host, Port, PrePath, PostPath, PPV_ServerID):
      self.protocol = Protocol
      self.host = Host
      self.port = Port
      self.path = PrePath
      self.ekstension = PostPath
      self.ppv_serverid = PPV_ServerID
      

    def SearchableText(self):
        """
            text for indexing
        """
        return "%s %s" % (self.title, self.description)

    def cb_isMoveable(self):
	return 0

    def cb_isCopyable(self):
	"""
	  You can copy this object
	"""
	return 1

class LiveServerLogic (ServerLogic):
    meta_type = 'Media Manager Live Server Logic'

    inputPort = 0
    inputPath = '/'
    bandwidth = 'singleisdn'
    xsize = '240'
    ysize = '180'
    audioformat = 'background'
    video_quality = 'smooth'
    audience_rate = 'adults'

    def __init__(self, id, title='', description=''):
      ServerLogic.__init__(self, id, title, description)

    def editLive(self, inputPort, inputPath, bandwidth, xsize, ysize, audioformat, video_quality, audience_rate):
	if inputPort is not None:
		self.inputPort = inputPort
	if inputPath is not None:
		self.inputPath = inputPath
	if bandwidth is not None:
		self.bandwidth = bandwidth
	if xsize is not None:
		self.xsize = xsize
	if ysize is not None:
		self.ysize = ysize
	if audioformat is not None:
		self.audioformat = audioformat
	if video_quality is not None:
		self.video_quality = video_quality
	if audience_rate is not None:
		self.audience_rate = audience_rate

def addLiveServerLogic(self, id, title='', REQUEST=None):
	ob = LiveServerLogic(id, title)
	self._setObject(id, ob)

def addServerLogic(self, id, title='', REQUEST=None):
	ob=ServerLogic(id,title)
	self._setObject(id, ob)

Globals.InitializeClass(ServerLogic)
Globals.InitializeClass(LiveServerLogic)

from Products.CMFCore.register import registerPortalContent
registerPortalContent(ServerLogic,
                      constructors=(addServerLogic,),
		      action='serverlogic_edit_form',
		      icon='file_icon.gif')
registerPortalContent(LiveServerLogic,
                      constructors=(addServerLogic,),
		      action='liveserverlogic_edit_form',
		      icon='file_icon.gif')
